package com.nstbushneva.automation.module2.api.steps;

import static net.serenitybdd.rest.SerenityRest.given;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import com.nstbushneva.automation.commons.Settings;
import cucumber.api.java.en.*;
import io.restassured.response.Response;
import io.restassured.specification.RequestSpecification;

public class BaseApiSteps {

  private Settings settings = new Settings();
  private Response response;
  private RequestSpecification request = given().log().method().and().log().uri();


  @Given("^Report Portal is up and running$")
  public void is_report_portal_runninng() {
    response = request.auth().oauth2(settings.bearerToken)
        .get(settings.rpUrl + settings.rpBaseUrl + "/heartbeat");
    assertEquals(response.getStatusCode(), 200);
  }

  @When("^Default user is ([^\"]*)$")
  public void is_report_portal_runninng(String username) {
    response = request.auth().oauth2(settings.bearerToken)
        .get(settings.rpUrl + settings.rpBaseUrl + "/user");
    assertEquals(response.getStatusCode(), 200);
    assertTrue(response.getBody().asString().contains(username));
  }

  @Then("^The project with name ([^\"]*) exists in the Report Portal for the specified user$")
  public void request_project_activity_by_name(String projectName) {
    response = request.auth().oauth2(settings.bearerToken)
                      .get(settings.rpUrl + settings.rpBaseUrl + "/project/" + projectName);
    assertEquals(response.getStatusCode(), 200);
  }
}